<?php
/*
 * *****************************************************************************
 * OUS Statistik (=ous_stt0301_lastyear); nach Jahr/Monat und Abteilung/Theke
 * *****************************************************************************
 * - Neu Intranet: 27.02.2015 /TZ
 *
 * @note: Die Statistiken lassen sich zu jeder Zeit & nach Bedarf abrufen. 
 * 
 * @todo:
 * - Benutzertyp 11?
 * - Schrott lesbar/ordentlich/nachvollziehbar machen
 * - Nur Kasse pro Tag bzw. überhaupt tagesgenaue Option?
 * - theken schlauer posten, andererseits so leicht manuell anpassbar...
 * - Nutzeraktivität monatlich... hmm - das wäre als cron & automatisch am 
 *   ehesten interessant
 * - $query_heading etwas schwer leserlich evtl.; fasst nun auch nicht alle
 *    Details der Formularauswahl zusammen...
 */
// Datenbankverbindung
require_once('../../inc/lbs-conf.php');

/*##############################################################################
 * Config...
 #############################################################################*/
$conf_disable_costs = false; //never show fees etc.


/*##############################################################################
 * Variabeln von Formular oder URL-Parametern via POST
 #############################################################################*/
$now    = date("d.m.Y H:i");
$title  = 'OUS: Benutzungsstatistik';


// Form: Nach Datum einschränken; default auf Monatsstatistik, letzter Monat
$year_from  = (isset($_REQUEST['year_from']))  ? $_REQUEST['year_from']  : date('Y');
$year_to    = (isset($_REQUEST['year_to']))    ? $_REQUEST['year_to']    : date('Y');
$month_from = (isset($_REQUEST['month_from'])) ? $_REQUEST['month_from'] : date('m')-1;
$month_to   = (isset($_REQUEST['month_to']))   ? $_REQUEST['month_to']   : date('m')-1;

// SQL-konformes Datum (kleiner nächster Monat)
$sql_date_from = date('Y-m-d 00:00:00', mktime(0, 0, 0, $month_from, 1, $year_from));
$sql_date_to   = date('Y-m-d 00:00:00', mktime(0, 0, 0, $month_to+1, 1, $year_to));

// "Sprechende" Daten (t=number of days in given month)
$usr_from = date('d.m.Y', mktime(0, 0, 0, $month_from, 1, $year_from));
$usr_to   = date('t.m.Y', mktime(0, 0, 0, $month_to, 1, $year_to));
$query_heading = "Statistikdaten vom $usr_from bis zum $usr_to";

// Form: details (grouping)
$sql_grouping = (isset($_REQUEST['opt_grouping']))  ? $_REQUEST['opt_grouping']  : 3;

// Form: Anzeigedetails
// Select liefert "on" bei aktiviert, gilt ansonsten als isset()==false.
if (isset($_REQUEST['submit'])) {
  $sql_details      = (isset($_REQUEST['opt_details']))       ? 1 : 0;
  $sql_detail_order = (isset($_REQUEST['opt_detail_order']))  ? 1 : 0;
} else {
  // defaults
  $sql_details      = 1;
  $sql_detail_order = 0;
}
$query_heading = ($sql_details == 1) ? "Detailierte $query_heading" : "Kompakte $query_heading";

// Form: Gebührenanzeige
$sql_costs = (isset($_REQUEST['opt_costs']))  ? $_REQUEST['opt_costs']  : 1;

// Form: Thekenwahl
if (isset($_REQUEST['opt_theken'])) $sql_theken = $_REQUEST['opt_theken'];
// Heading for this "Report"
if (!isset($sql_theken)) {
  $query_heading .= " für alle Theken";
}
// Form send, but everything selected
elseif (count(array_diff($sql_theken, array(1))) == 0) {
  $query_heading .= " für alle Theken";
}
else {
  $query_heading .= " für die Theken:<br />";
  $tmp = array_diff($sql_theken, array(0));
  $tmp = array_keys($tmp);
  $query_heading .= implode(', ', $tmp);
}


/*##############################################################################
 * Filterung (Formular)
 #############################################################################*/
function frm_selects_year($postfix, $selected = 0) {
  $select_year = "<select name=\"year_$postfix\">";
  for ($year = date('Y'); $year >= 1999; $year--) {
    $select_opt = ($year == $selected) ? 'selected' : '';
    $select_year .= "<option $select_opt>$year</option>\n";
  }
  $select_year .= '<select>';

  return $select_year;
}

function frm_selects_month($postfix, $selected = 0) {
  $select_month = "<select name=\"month_$postfix\">\n";
  for ($month = 1; $month <= 12; $month++) {
    $select_opt = ($month == $selected) ? 'selected' : '';
    $select_month .= "<option $select_opt>$month</option>\n";
  }
  $select_month .= '<select>';

  return $select_month;
}

function frm_checkbox_theken($cols = 5) {
  global $conn, $iln, $sql_theken;

  $query  = "SELECT counter_number 'id', description 'name' FROM counter WHERE iln = $iln ORDER BY counter_number";
  $result = sybase_query("$query", $conn) or die ("# ERROR: Query in Sybase failed $now \n"); // todo mail an admin

  $theken = '<table><tr>';
  $i = 0;
  while ($row = sybase_fetch_array($result)) {
    $id = $row['id'];

    if (isset($sql_theken)) {
      $checked  = ($sql_theken[$id] == 1) ? 'checked="checked"' : '';
      $value    = $sql_theken[$id];
    } else {
      $checked  = 'checked="checked"';
      $value    = '1'; 
    }

    $theken .= ($i % $cols == 0) ? '</tr><tr>' : '';
    $theken .= '<td class="left">
                <input type="checkbox" id="theke_'.$id.'" onclick="toggle_theke(this.checked, '.$id.')" '.$checked.'>
                <input type="hidden" name="opt_theken['.$id.']" id="opt_theke_'.$id.'" value="'.$value.'">
                <label for="theke_'.$id.'">'.$id.': '.utf8_encode($row['name']).'</label></td>';

    $i++;
  }

  $i = $cols - ($i % $cols);
  $theken .= ($i != $cols) ? '<td colspan="'.$i.'"></td></tr></table>' : '</tr></table>';

  return $theken;
}

function frm_select_costs($select_id) {
  global $conf_disable_costs;

  if ($conf_disable_costs == true) return '';

  $options[1] = 'Alle Gebühren';
  $options[2] = 'Keine Gebühren';
  $options[3] = 'Nur beglichene Gebühren';
  //$options[4] = 'Nur ausstehende Gebühren';

  $select = '<label for="opt_costs">Zeige: </label><select name="opt_costs">';
  foreach ($options AS $id => $text) {
    $selected = ($id == $select_id) ? 'selected="selected"' : '';
    $select .= "<option value=\"$id\" $selected>$text</option>\n";
  }
  $select .= '</select>';

  return $select;
}


$form  = '<form name="stat_options" class="custom_form" action="">
            <fieldset>
              <legend>Zeitraum (Monat/Jahr)</legend>
            Von ';
$form .= frm_selects_month('from', $month_from);
$form .= frm_selects_year('from', $year_from);
$form .= ' bis ';
$form .= frm_selects_month('to', $month_to);
$form .= frm_selects_year('to', $year_to);
$form .=   '</fieldset>
           <fieldset>
              <legend>Gliederungsdetails (wenig &gt;&gt; mehr)</legend>
                Für den gewählten Zeitraum Summen bilden nur nach...<br />
                <input type="radio" name="opt_grouping" id="lbl_grp0" value="0"><label for="lbl_grp0">Nur Bestand</label><br />
                <input type="radio" name="opt_grouping" id="lbl_grp1" value="1"><label for="lbl_grp1">Nur Abteilungen</label><br />
                <input type="radio" name="opt_grouping" id="lbl_grp2" value="2"><label for="lbl_grp2">Nur Theken</label><br />
                <input type="radio" name="opt_grouping" id="lbl_grp3" value="3"><label for="lbl_grp3">Abteilung und Theken</label>
              </legend>
            </fieldset>
           <fieldset>
              <legend>Anzeigedetails</legend>
                <input type="checkbox" name="opt_details" id="opt_details" onclick="toggle_sort(this.checked)"><label for="opt_details">Details pro Counter zeigen (Bezeichnung und Code, z.B. einzelne Benutzertypen)</label><br />
                <input type="checkbox" name="opt_detail_order" id="opt_detail_order"><label for="opt_detail_order">Ich bin Praktikant, sortier bitte nach den Bezeichnungen, nicht nach den Codes.</label><br />';
$form .=  frm_select_costs($sql_costs);
$form .=  '   </legend>
            </fieldset>
           <fieldset>
              <legend>Nur bestimmte Theken einbeziehen</legend>';
$form .=  frm_checkbox_theken();
$form .=   '  </legend>
            </fieldset>';
$form .=    '<br><input type="hidden" name="submit" value="1"/><button type="submit">Absenden</button>
          </form>';


/*##############################################################################
 * SQL-Query-Vorbereitung
 * > Logisch sinnvolle Group-Reihenfolge: (iln), Abteilung, fno, Theke, counter_id, counter_code
 * >
 #############################################################################*/
$sql_where = array();
$sql_group = array();
$sql_order = array();
//sql a) Detail: Abteilung
$detail['Abteilung']['use']     = ($sql_grouping == '1' || $sql_grouping == '3') ?  true : false;
$detail['Abteilung']['select']  = "(SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 19 AND convert(int, code_value) = stat.department) 'Abteilung'";
if ($detail['Abteilung']['use'] === true) $sql_group[] = $sql_order[] = 'stat.department';

//sql b) Detail: fno (immer)
$sql_group[] = 'stat.fno';

////sql c) Detail: Theke
$detail['Theke']['use']         = ($sql_grouping == '2' || $sql_grouping == '3') ?  true : false;
$detail['Theke']['select']      = "'Theke ' || convert(varchar(4), stat.counter) || ': ' || (SELECT description FROM counter WHERE iln = $iln AND counter_number = stat.counter) 'Theke'";
if ($detail['Theke']['use'] === true) $sql_group[] = $sql_order[] = 'stat.counter';

// remove all value = 0, then get the keys, then implode; tmp just for better understanding...
if (isset($_REQUEST['submit'])) {
  $tmp = array_diff($sql_theken, array(0));
  $tmp = array_keys($tmp);
  $sql_where[] = '(stat.counter = '.implode(' OR stat.counter = ', $tmp).')';
}

//sql d) counter_id "Zählerkategorie": immer, daher select im query direkt
$sql_group[] = $sql_order[] = 'stat.counter_id';

//sql e) counter_code "Zählerdetail": immer
$detail['Counter_Code']['use']    = ($sql_details == 1) ?  true : false;
$detail['Counter_Code']['select'] = "(CASE stat.counter_id
              -- Hinter jedem Subquery-SELECT folgt  || '' - merkwürdigerweise ganz selten kein Ergebnis in DB, php-isset() gibt dann false zurück
          		WHEN 101 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 6  AND code_value = stat.counter_code) || '' --'Kostenart'
          		WHEN 102 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 6  AND code_value = stat.counter_code) || '' --'Kostenart'
          		WHEN 104 THEN 'Ausleihstatus neu: ' || (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 3 AND code_value = stat.counter_code)
          		WHEN 105 THEN 'Ausleihstatus alt: ' || (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 3 AND code_value = stat.counter_code)
          		WHEN 106 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 1  AND code_value = stat.counter_code) || '' --'Nutzertyp'
          		WHEN 107 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 10 AND code_value = stat.counter_code) || '' --'Ausleihtyp'
          		WHEN 108 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 8  AND code_value = stat.counter_code) || '' --'Materialart'
          		WHEN 109 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 1  AND code_value = stat.counter_code) || '' --'Nutzertyp'
          		WHEN 110 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 10 AND code_value = stat.counter_code) || '' --'Ausleihtyp'
          		WHEN 111 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 8  AND code_value = stat.counter_code) || '' --'Materialart'
          		WHEN 112 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 1  AND code_value = stat.counter_code) || '' --'Nutzertyp'
          		WHEN 113 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 10 AND code_value = stat.counter_code) || '' --'Ausleihtyp'
          		WHEN 114 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 8  AND code_value = stat.counter_code) || '' --'Materialart'
          		WHEN 118 THEN 'Ausleihstatus alt: ' || (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 3 AND code_value = stat.counter_code)
          		WHEN 126 THEN 'Aufnahmeart'
          		WHEN 127 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 1  AND code_value = stat.counter_code) || '' --'Nutzertyp'
          		WHEN 128 THEN 'Mahnstufe'
          		WHEN 129 THEN 'Mahnstufe'
          		WHEN 130 THEN 'Mahnstufe'
          		WHEN 136 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 1  AND code_value = stat.counter_code) || '' --'Nutzertyp'
          		WHEN 137 THEN 'Nutzer_id'
          		WHEN 138 THEN 'Nutzer_id'
          		WHEN 141 THEN 'Nutzer_id'
          		WHEN 142 THEN '142'
          		WHEN 144 THEN 'Betrag'
          		WHEN 145 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 1  AND code_value = stat.counter_code) || '' --'Nutzertyp'
          		WHEN 146 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 10 AND code_value = stat.counter_code) || '' --'Ausleihtyp'
          		WHEN 147 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 8  AND code_value = stat.counter_code) || '' --'Materialart'
          		WHEN 148 THEN '148'
          		WHEN 149 THEN '149'
          		WHEN 150 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 1  AND code_value = stat.counter_code) || '' --'Nutzertyp'
          		WHEN 151 THEN (SELECT description FROM lbs_code_desc WHERE iln = $iln AND language_code = 'DE' AND code_id = 8  AND code_value = stat.counter_code) || '' --'Materialart'
          		ELSE '-'
          	END) 'Bezeichnung'";
$detail['Counter_Code']['select'] .= ", stat.counter_code 'Code'";
if ($sql_details == 1) {
  $sql_group[] = 'counter_code';
  $sql_order[] = ($sql_detail_order == 1) ? "'Bezeichnung', convert(int, counter_code)" : 'convert(int, counter_code)';
}


//sql f) Kosten zeigen
if ($conf_disable_costs == true) $sql_costs = 2;
switch($sql_costs) {
  case 1: break; //all
  case 2:
    $sql_where[] = 'stat.counter_id NOT IN (101, 102, 127, 152, 153)'; // None
    break;
  case 3:
    $sql_where[] = 'stat.counter_id NOT IN (102, 127, 152, 153)'; // beglichen
    break;
  case 4:
    //$sql_where[] = 'stat.counter_id <> 101'; // ausstehend -  blödsinn...
    break;
}


/*##############################################################################
 * Build query
 #############################################################################*/
$query  = "SELECT ";
$query .=   ($detail['Abteilung']['use'] === true) ? $detail['Abteilung']['select'].",\n" : '';
$query .= "	stat.fno,";
$query .=   ($detail['Theke']['use'] === true) ? $detail['Theke']['select'].",\n" : '';
$query .= " (CASE stat.counter_id
          		WHEN 101 THEN 'Forderungen: beglichen'
          		WHEN 102 THEN 'Forderungen: ausstehend'
          		WHEN 103 THEN 'Bestellungen'
          		WHEN 104 THEN 'Ankunft Theke'
          		WHEN 105 THEN 'Ausleihen pro Ausleihstatus' 				--Ausgaben
          		WHEN 106 THEN 'Ausleihen pro Nutzertyp'  					--Ausgaben
          		WHEN 107 THEN 'Ausleihen pro Ausleihtyp'					--Ausgaben
          		WHEN 108 THEN 'Ausleihen pro Materialart'					--Ausgaben
          		WHEN 109 THEN 'Freihandausleihen pro Nutzertyp'				--Freihandausleihen
          		WHEN 110 THEN 'Freihandausleihen pro Ausleihtyp'			--Freihandausleihen
          		WHEN 111 THEN 'Freihandausleihen pro Materialart'			--Freihandausleihen
          		WHEN 112 THEN 'Verlängerungen incl. OPAC pro Nutzertyp'		--Verlaengerungen
          		WHEN 113 THEN 'Verlängerungen incl. OPAC pro Ausleihtyp'	--Verlaengerungen
          		WHEN 114 THEN 'Verlängerungen incl. OPAC pro Materialart'	--Verlaengerungen
          		WHEN 115 THEN 'Rücknahmen ins Regal'
          		WHEN 116 THEN 'Normale Rücknahmen'
          		WHEN 117 THEN 'Rücknahmen für andere Abteilung'
          		WHEN 118 THEN 'Rücknahmen ohne Ausgabe'						--Ruecknahme nicht ausgegeb. Best.
          		WHEN 119 THEN 'Umgesetzte Bandvormerkungen'
          		WHEN 120 THEN 'Umgesetzte Titelvormerkungen'
          		WHEN 121 THEN 'Bandvormerkungen'
          		WHEN 122 THEN 'Titelvormerkungen'
          		WHEN 123 THEN 'Stornierte Bandvormerkungen'
          		WHEN 124 THEN 'Stornierte Titelvormerkungen'
          		WHEN 125 THEN 'Aufgenommene Bände'
          		WHEN 126 THEN 'Aufgenommene Nutzer'
          		WHEN 127 THEN 'Aufgelaufene Mitgliedsbeiträge (EUR)'
          		WHEN 128 THEN 'Mahnungen'
          		WHEN 129 THEN 'Mahnungen - in Rechnung gestellt'
          		WHEN 130 THEN 'Mahnbeträge ---gibt es nicht'
          		WHEN 131 THEN 'Geänderte Ausleihen'
          		WHEN 132 THEN 'OPAC - Bestellungen'
          		WHEN 133 THEN 'OPAC - Eingegebene Bände'
          		WHEN 134 THEN 'OPAC - Bandvormerkungen'
          		WHEN 135 THEN 'OPAC - Verlängerungen'
          		WHEN 136 THEN 'Beiträge für REGIO-Mitglieder'
          		WHEN 137 THEN 'OPAC - Auf lokalen Server heruntergeladene Titel'
          		WHEN 138 THEN 'OPAC - Auf Schirm heruntergeladene Titel'
          		WHEN 139 THEN 'OPAC - Freie Bestellungen'
          		WHEN 140 THEN 'OPAC - Titelvormerkungen'
          		WHEN 141 THEN 'OPAC - Mit E-Mail heruntergeladene Titel'
          		WHEN 142 THEN '142'
          		WHEN 143 THEN 'OPAC - Stornierte Vormerkungen'
          		WHEN 144 THEN 'Forderungen gemindert um...'
          		WHEN 145 THEN '145'
          		WHEN 146 THEN '146'
          		WHEN 147 THEN '147'
          		WHEN 148 THEN '148'
          		WHEN 149 THEN '149'
          		WHEN 150 THEN 'Nutzerlöschungen'
          		WHEN 151 THEN 'Bandlöschungen'
          		WHEN 152 THEN 'Summe ausgebuchter Band-Vormerkgebühren'
          		WHEN 153 THEN 'Summe ausgebuchter Titel-Vormerkgebühren'
          		ELSE 'Unbekannter Counter: ' || convert(varchar, stat.counter_id)
          	END) 'Counter',";
$query .=   ($detail['Counter_Code']['use'] === true) ? $detail['Counter_Code']['select'].",\n" : '';
$query .= "	(CASE stat.counter_id
          		WHEN 101 THEN SUM(convert(numeric(15,2), stat.number)) / 100 --von Cent auf Euro für beglichene Forderungen
          		WHEN 102 THEN SUM(convert(numeric(15,2), stat.number)) / 100 --von Cent auf Euro für ausgebuchte/unbeglichene Forderungen
          		WHEN 127 THEN SUM(convert(numeric(15,2), stat.number)) / 100 --von Cent auf Euro für Ausweisgebühren
              WHEN 152 THEN SUM(convert(numeric(15,2), stat.number)) / 100 --von Cent auf Euro für ausgebuchter Band-Vormerkgebühren
              WHEN 153 THEN SUM(convert(numeric(15,2), stat.number)) / 100 --von Cent auf Euro für ausgebuchter Titel-Vormerkgebühren
          		ELSE SUM(convert(numeric(10,0), stat.number))
          	END) 'Summe',
            stat.counter_id 'Counter-ID'
          FROM lbs_statistics stat
          WHERE stat.iln = $iln
            AND stat.date >= '$sql_date_from' AND stat.date < '$sql_date_to' --custom\n";
$query .= (count($sql_where) > 0) ?  'AND '.implode("\n AND ", $sql_where)."\n" : '';
$query .= ' AND stat.counter_id > 100 -- darunter erscheint für 50+51 noch etwas, aber nicht zuordbar, was die aussagen
          	AND stat.counter_id < 154 -- 154 scheint nichts mehr zu sagen...
          	-- Man kann die Nutzergruppen rausfiltern, die ohnehin keine Ausweisgebühren zahlen; bei TUB alle Nutergruppen bis 33
--          	AND NOT (stat.counter_id = 127 AND convert(int, counter_code) < 34)
          GROUP BY ';
$query .=   implode(",\n", $sql_group);
$query .= "
--        HAVING
--          SUM(stat.number) > 0
          ORDER BY ";
$query .=   implode(",\n", $sql_order);
//echo '<pre>'.$query;


/*##############################################################################
 * Standardabfragen
 #############################################################################*/
$link_month = date('m')-1;
$link_year  = ($link_month != 12) ? date('Y') : date('Y')-1;

// CR: OUS_Thekenstatistik_detailliert_monatlich.rpt (Fernleihe 830, detailiert)
// [TUHH-OUS-Statistik]: 
$links['fl_monat']  = '<a href="ous_statistik.php?month_from='.$link_month.'&year_from='.$link_year.'&month_to='.$link_month.'&year_to='.$link_year;
$links['fl_monat'] .= '&opt_grouping=2&opt_details=on&opt_costs=2';
$links['fl_monat'] .= '&opt_theken%5B1%5D=0&opt_theken%5B2%5D=0&opt_theken%5B3%5D=0&opt_theken%5B6%5D=0&opt_theken%5B9%5D=0&opt_theken%5B13%5D=0&opt_theken%5B18%5D=0&opt_theken%5B21%5D=0&opt_theken%5B23%5D=0&opt_theken%5B51%5D=0&opt_theken%5B52%5D=0&opt_theken%5B53%5D=0&opt_theken%5B54%5D=0&opt_theken%5B55%5D=0&opt_theken%5B56%5D=0&opt_theken%5B57%5D=0&opt_theken%5B71%5D=0&opt_theken%5B99%5D=0&opt_theken%5B102%5D=0&opt_theken%5B201%5D=0&opt_theken%5B202%5D=0&opt_theken%5B203%5D=0&opt_theken%5B222%5D=0&opt_theken%5B250%5D=0&opt_theken%5B280%5D=0&opt_theken%5B607%5D=0&opt_theken%5B611%5D=0&opt_theken%5B612%5D=0&opt_theken%5B613%5D=0&opt_theken%5B614%5D=0&opt_theken%5B615%5D=0&opt_theken%5B616%5D=0&opt_theken%5B662%5D=0&opt_theken%5B664%5D=0&opt_theken%5B830%5D=1&opt_theken%5B1004%5D=0&opt_theken%5B1010%5D=0&opt_theken%5B2011%5D=0&opt_theken%5B3000%5D=0&opt_theken%5B6115%5D=0&opt_theken%5B6135%5D=0';
$links['fl_monat'] .= '&submit=1">(CR TUB/HCU) OUS: Ausleihstatistik Fernleihe für letzten Monat</a> (Gezählt werden nur Monografien. Passive Fernleihe: Bestellungen + Freihandausleihen pro Nutzertyp 2; Aktive Fernleihe: Freihandausleihen pro Nutzertyp 51)';
$links['fl_monat'] .= '<br>Crystal Report derzeit an: xxx';

// CR: OUS_Thekenstatistik_detailliert_monatlich.rpt (Selfcheck 201/202/203, detailiert)
// [TUHH-OUS-Statistik]: 
$links['sc_monat']  = '<a href="ous_statistik.php?month_from='.$link_month.'&year_from='.$link_year.'&month_to='.$link_month.'&year_to='.$link_year;
$links['sc_monat'] .= '&opt_grouping=2&opt_details=on&opt_costs=2';
$links['sc_monat'] .= '&opt_theken%5B1%5D=0&opt_theken%5B2%5D=0&opt_theken%5B3%5D=0&opt_theken%5B6%5D=0&opt_theken%5B9%5D=0&opt_theken%5B13%5D=0&opt_theken%5B18%5D=0&opt_theken%5B21%5D=0&opt_theken%5B23%5D=0&opt_theken%5B51%5D=0&opt_theken%5B52%5D=0&opt_theken%5B53%5D=0&opt_theken%5B54%5D=0&opt_theken%5B55%5D=0&opt_theken%5B56%5D=0&opt_theken%5B57%5D=0&opt_theken%5B71%5D=0&opt_theken%5B99%5D=0&opt_theken%5B102%5D=0&opt_theken%5B201%5D=1&opt_theken%5B202%5D=1&opt_theken%5B203%5D=1&opt_theken%5B222%5D=0&opt_theken%5B250%5D=0&opt_theken%5B280%5D=0&opt_theken%5B607%5D=0&opt_theken%5B611%5D=0&opt_theken%5B612%5D=0&opt_theken%5B613%5D=0&opt_theken%5B614%5D=0&opt_theken%5B615%5D=0&opt_theken%5B616%5D=0&opt_theken%5B662%5D=0&opt_theken%5B664%5D=0&opt_theken%5B830%5D=0&opt_theken%5B1004%5D=0&opt_theken%5B1010%5D=0&opt_theken%5B2011%5D=0&opt_theken%5B3000%5D=0&opt_theken%5B6115%5D=0&opt_theken%5B6135%5D=0';
$links['sc_monat'] .= '&submit=1">(CR TUB/HCU) OUS: Ausleihstatistik Selbstverbucher für letzten Monat</a>';
$links['sc_monat'] .= '<br>Crystal Report derzeit an: xxx';

// CR: OUS_Thekenstatistik_detaillierte_Jahresuebersicht.rpt (detailiert)
$links['iln_jahr']  = '<a href="ous_statistik.php?month_from=1&year_from='.(date('Y')-1).'&month_to=12&year_to='.(date('Y')-1);
$links['iln_jahr'] .= '&opt_grouping=2&opt_details=on&opt_costs=2';
$links['iln_jahr'] .= '&opt_theken%5B1%5D=1&opt_theken%5B2%5D=1&opt_theken%5B3%5D=1&opt_theken%5B6%5D=1&opt_theken%5B9%5D=1&opt_theken%5B13%5D=1&opt_theken%5B18%5D=1&opt_theken%5B21%5D=1&opt_theken%5B23%5D=1&opt_theken%5B51%5D=1&opt_theken%5B52%5D=1&opt_theken%5B53%5D=1&opt_theken%5B54%5D=1&opt_theken%5B55%5D=1&opt_theken%5B56%5D=1&opt_theken%5B57%5D=1&opt_theken%5B71%5D=1&opt_theken%5B99%5D=1&opt_theken%5B102%5D=1&opt_theken%5B201%5D=1&opt_theken%5B202%5D=1&opt_theken%5B203%5D=1&opt_theken%5B222%5D=1&opt_theken%5B250%5D=1&opt_theken%5B280%5D=1&opt_theken%5B607%5D=1&opt_theken%5B611%5D=1&opt_theken%5B612%5D=1&opt_theken%5B613%5D=1&opt_theken%5B614%5D=1&opt_theken%5B615%5D=1&opt_theken%5B616%5D=1&opt_theken%5B662%5D=1&opt_theken%5B664%5D=1&opt_theken%5B830%5D=1&opt_theken%5B1004%5D=1&opt_theken%5B1010%5D=1&opt_theken%5B2011%5D=1&opt_theken%5B3000%5D=1&opt_theken%5B6115%5D=1&opt_theken%5B6135%5D=1';
$links['iln_jahr'] .= '&submit=1">(CR TUB/HCU) OUS: Ausleihstatistik für alle Theken für letztes Jahr</a>';
$links['iln_jahr'] .= '<br>Crystal Report derzeit an: xxx';

// DECT: OUS-Jahresstatistik für letztes Jahr; pica/sqruser/sc/tuhh_ous_stat_jahr
$links['iln_jahr2']  = '<a href="ous_statistik.php?month_from=1&year_from='.(date('Y')-1).'&month_to=12&year_to='.(date('Y')-1);
$links['iln_jahr2'] .= '&opt_grouping=1&opt_details=on&opt_costs=1';
$links['iln_jahr2'] .= '&opt_theken%5B1%5D=1&opt_theken%5B2%5D=1&opt_theken%5B3%5D=1&opt_theken%5B6%5D=1&opt_theken%5B9%5D=1&opt_theken%5B13%5D=1&opt_theken%5B18%5D=1&opt_theken%5B21%5D=1&opt_theken%5B23%5D=1&opt_theken%5B51%5D=1&opt_theken%5B52%5D=1&opt_theken%5B53%5D=1&opt_theken%5B54%5D=1&opt_theken%5B55%5D=1&opt_theken%5B56%5D=1&opt_theken%5B57%5D=1&opt_theken%5B71%5D=1&opt_theken%5B99%5D=1&opt_theken%5B102%5D=1&opt_theken%5B201%5D=1&opt_theken%5B202%5D=1&opt_theken%5B203%5D=1&opt_theken%5B222%5D=1&opt_theken%5B250%5D=1&opt_theken%5B280%5D=1&opt_theken%5B607%5D=1&opt_theken%5B611%5D=1&opt_theken%5B612%5D=1&opt_theken%5B613%5D=1&opt_theken%5B614%5D=1&opt_theken%5B615%5D=1&opt_theken%5B616%5D=1&opt_theken%5B662%5D=1&opt_theken%5B664%5D=1&opt_theken%5B830%5D=1&opt_theken%5B1004%5D=1&opt_theken%5B1010%5D=1&opt_theken%5B2011%5D=1&opt_theken%5B3000%5D=1&opt_theken%5B6115%5D=1&opt_theken%5B6135%5D=1';
$links['iln_jahr2'] .= '&submit=1">(SQR TUB/HCU) OUS-Jahresstatistik für letztes Jahr</a>';
$links['iln_jahr2'] .= '<br>SQR derzeit an: xxx';

// DECT: OUS-Statistik fuer letzten <Monat> <Jahr>; pica/sqruser/sc/tuhh_ous_stat_monat
$links['iln_monat']  = '<a href="ous_statistik.php?month_from='.$link_month.'&year_from='.$link_year.'&month_to='.$link_month.'&year_to='.$link_year;
$links['iln_monat'] .= '&opt_grouping=1&opt_details=on&opt_costs=1';
$links['iln_monat'] .= '&opt_theken%5B1%5D=1&opt_theken%5B2%5D=1&opt_theken%5B3%5D=1&opt_theken%5B6%5D=1&opt_theken%5B9%5D=1&opt_theken%5B13%5D=1&opt_theken%5B18%5D=1&opt_theken%5B21%5D=1&opt_theken%5B23%5D=1&opt_theken%5B51%5D=1&opt_theken%5B52%5D=1&opt_theken%5B53%5D=1&opt_theken%5B54%5D=1&opt_theken%5B55%5D=1&opt_theken%5B56%5D=1&opt_theken%5B57%5D=1&opt_theken%5B71%5D=1&opt_theken%5B99%5D=1&opt_theken%5B102%5D=1&opt_theken%5B201%5D=1&opt_theken%5B202%5D=1&opt_theken%5B203%5D=1&opt_theken%5B222%5D=1&opt_theken%5B250%5D=1&opt_theken%5B280%5D=1&opt_theken%5B607%5D=1&opt_theken%5B611%5D=1&opt_theken%5B612%5D=1&opt_theken%5B613%5D=1&opt_theken%5B614%5D=1&opt_theken%5B615%5D=1&opt_theken%5B616%5D=1&opt_theken%5B662%5D=1&opt_theken%5B664%5D=1&opt_theken%5B830%5D=1&opt_theken%5B1004%5D=1&opt_theken%5B1010%5D=1&opt_theken%5B2011%5D=1&opt_theken%5B3000%5D=1&opt_theken%5B6115%5D=1&opt_theken%5B6135%5D=1';
$links['iln_monat'] .= '&submit=1">(SQ TUB/HCUR) OUS-Statistik fuer letzten Monat</a> (ohne Nutzeraktivität)';
$links['iln_monat'] .= '<br>SQR derzeit an: xxx';

// DECT: OUS-Fernleihstatistik fuer letztes Jahr; pica/sqruser/sc/tuhh_ous_stat_jahr_fernleihe
$links['fl_jahr']  = '<a href="ous_statistik.php?month_from=1&year_from='.(date('Y')-1).'&month_to=12&year_to='.(date('Y')-1);
$links['fl_jahr'] .= '&opt_grouping=2&opt_details=on&opt_costs=1';
$links['fl_jahr'] .= '&opt_theken%5B1%5D=0&opt_theken%5B2%5D=0&opt_theken%5B3%5D=0&opt_theken%5B6%5D=0&opt_theken%5B9%5D=0&opt_theken%5B13%5D=0&opt_theken%5B18%5D=0&opt_theken%5B21%5D=0&opt_theken%5B23%5D=0&opt_theken%5B51%5D=0&opt_theken%5B52%5D=0&opt_theken%5B53%5D=0&opt_theken%5B54%5D=0&opt_theken%5B55%5D=0&opt_theken%5B56%5D=0&opt_theken%5B57%5D=0&opt_theken%5B71%5D=0&opt_theken%5B99%5D=0&opt_theken%5B102%5D=0&opt_theken%5B201%5D=0&opt_theken%5B202%5D=0&opt_theken%5B203%5D=0&opt_theken%5B222%5D=0&opt_theken%5B250%5D=0&opt_theken%5B280%5D=0&opt_theken%5B607%5D=0&opt_theken%5B611%5D=0&opt_theken%5B612%5D=0&opt_theken%5B613%5D=0&opt_theken%5B614%5D=0&opt_theken%5B615%5D=0&opt_theken%5B616%5D=0&opt_theken%5B662%5D=0&opt_theken%5B664%5D=0&opt_theken%5B830%5D=1&opt_theken%5B1004%5D=0&opt_theken%5B1010%5D=0&opt_theken%5B2011%5D=0&opt_theken%5B3000%5D=0&opt_theken%5B6115%5D=0&opt_theken%5B6135%5D=0';
$links['fl_jahr'] .= '&submit=1">(SQR TUB) OUS-Fernleihstatistik für letztes Jahr</a> (Gezählt werden nur Monografien. Passive Fernleihe: Bestellungen + Freihandausleihen pro Nutzertyp 2; Aktive Fernleihe: Freihandausleihen pro Nutzertyp 51)';
$links['fl_jahr'] .= '<br>SQR derzeit an: xxx';

// DECT: OUS: Selbstverbucherstatisik für letzten Jahr; pica/sqruser/sc/tuhh_ous_stat_jahr_fernleihe
$links['sc_jahr']  = '<a href="ous_statistik.php?month_from=1&year_from='.(date('Y')-1).'&month_to=12&year_to='.(date('Y')-1);
$links['sc_jahr'] .= '&opt_grouping=2&opt_details=on&opt_costs=2';
$links['sc_jahr'] .= '&opt_theken%5B1%5D=0&opt_theken%5B2%5D=0&opt_theken%5B3%5D=0&opt_theken%5B6%5D=0&opt_theken%5B9%5D=0&opt_theken%5B13%5D=0&opt_theken%5B18%5D=0&opt_theken%5B21%5D=0&opt_theken%5B23%5D=0&opt_theken%5B51%5D=0&opt_theken%5B52%5D=0&opt_theken%5B53%5D=0&opt_theken%5B54%5D=0&opt_theken%5B55%5D=0&opt_theken%5B56%5D=0&opt_theken%5B57%5D=0&opt_theken%5B71%5D=0&opt_theken%5B99%5D=0&opt_theken%5B102%5D=0&opt_theken%5B201%5D=1&opt_theken%5B202%5D=1&opt_theken%5B203%5D=1&opt_theken%5B222%5D=0&opt_theken%5B250%5D=0&opt_theken%5B280%5D=0&opt_theken%5B607%5D=0&opt_theken%5B611%5D=0&opt_theken%5B612%5D=0&opt_theken%5B613%5D=0&opt_theken%5B614%5D=0&opt_theken%5B615%5D=0&opt_theken%5B616%5D=0&opt_theken%5B662%5D=0&opt_theken%5B664%5D=0&opt_theken%5B830%5D=0&opt_theken%5B1004%5D=0&opt_theken%5B1010%5D=0&opt_theken%5B2011%5D=0&opt_theken%5B3000%5D=0&opt_theken%5B6115%5D=0&opt_theken%5B6135%5D=0';
$links['sc_jahr'] .= '&submit=1">(SQR TUB) OUS: Selbstverbucherstatisik für letzten Jahr</a>';
$links['sc_jahr'] .= '<br>SQR derzeit an: xxx';



/*##############################################################################
 * Processing query and output
 #############################################################################*/
$result = sybase_query("$query", $conn) or die ("# ERROR: Query in Sybase failed $now \n"); // todo mail an admin

$div_result = $section_last_fno_department = $section_last_theke = $last_counter = $show_counter = '';
while ($row = sybase_fetch_array($result)) {
  // Table header pro Rubrik
  $table_head = "<table>
                <tr>
                  <!--<th>fno</th>-->
                  <th id=\"th_counter\">Counter</th>";
  $table_head .= (isset($row['Bezeichnung'])) ? '<th id="th_bezeichnung">Bezeichnung</th>'  : '';
  $table_head .= (isset($row['Code']))        ? '<th id="th_code">Code</th>'                : '';
  $table_head .=  "<th id=\"th_summe\">Summe</th>
                 </tr>\n";
  $new_table_head = false;

  // Rubrik FNO/Abteilung
  $section_fno_department = (isset($row['Abteilung'])) ? 'Bestand '.$row['fno'].', Abteilung: '.$row['Abteilung'] : 'Bestand '.$row['fno'];
  if ($section_fno_department !== $section_last_fno_department) {
    if ($section_last_fno_department !== '') $div_result .= '</table>';
    $div_result .= '<h3 class="section_abteilung">'.utf8_encode($section_fno_department).'</h3>';
    $section_last_fno_department = $section_fno_department;
    $last_counter = $show_counter = ''; // Always reset = always display
    $new_table_head = true;
  }

  // Rubrik Theke
  $section_theke = (isset($row['Theke'])) ? $row['Theke'] : false;
  if ($section_theke !== $section_last_theke) {
    if ($section_last_theke !== '') $div_result .= '</table>';
    $div_result .= '<h4 class="section_theke">'.utf8_encode($section_theke).'</h4>';
    $section_last_theke = $section_theke;
    $last_counter = $show_counter = ''; // Always reset = always display
    $new_table_head = true;
  }

  // Add head if section changed
  if ($new_table_head === true) $div_result .= $table_head;

  // Skip repeating counter
  $show_counter = ($row['Counter'] !== $last_counter) ? $row['Counter'] : '';
  $last_counter = $row['Counter'];

  //Format numbers (f*ck sybase, locals etc.)
  if ($row['Counter-ID'] == 101 || $row['Counter-ID'] == 102 || $row['Counter-ID'] == 127 || $row['Counter-ID'] == 152 || $row['Counter-ID'] == 153) {
    //$sum = money_format('%i', $row['Summe']); //nur mit de-locales
    $sum = number_format ($row['Summe'], 2, ",", ".").' EUR';
  } else {
    $sum = number_format ($row['Summe'], 0, "", "");
  }

  //<td>$row['fno']</td>
  $div_result .= "<tr>
                  <td class=\"left\">$show_counter</td>";
  $div_result .= (isset($row['Bezeichnung'])) ? "<td class=\"left\">".utf8_encode($row['Bezeichnung'])."&nbsp;</td>" : '';
  $div_result .= (isset($row['Code']))        ? "<td class=\"left\">".$row['Code']."&nbsp;</td>"        : '';
  $div_result .= "<td>$sum</td>
                  </tr>\n";
}

$div_result .= '</div>';


/*##############################################################################
 * JavaScript: Lazy version to remember form settings
 #############################################################################*/
$js = "<script type=\"text/javascript\">
        // Grouping
        document.getElementById('lbl_grp$sql_grouping').checked = true;

        // Details
        document.getElementById('opt_details').checked = $sql_details;

        // Details-Order
        toggle_sort($sql_details, $sql_detail_order);

        function toggle_sort(ownstatus, set_checked = 0) {
          if (ownstatus == 1) {
            document.getElementById('opt_detail_order').disabled = false;
            document.getElementById('opt_detail_order').checked = set_checked;
          } else {
            document.getElementById('opt_detail_order').disabled = true;
            document.getElementById('opt_detail_order').checked = false;
          }
        }

        //Thekenwahl
        function toggle_theke(ownstatus, id) {
          if (ownstatus == true) {
            document.getElementById('theke_'+id).checked = true; //nach post aktiviert setzen
            document.getElementById('opt_theke_'+id).value = 1;
          } else {
            document.getElementById('theke_'+id).checked = false; //nach post unchecked setzen
            document.getElementById('opt_theke_'+id).value = 0;
          }
        }

        // Visibility
        function toggle_visibility(id) {
          if (document.getElementById(id).style.display == 'block') {
            document.getElementById(id).style.display = 'none';
            document.getElementById('toggle_'+id).innerHTML = 'anzeigen';
          } else {
            document.getElementById(id).style.display = 'block';
            document.getElementById('toggle_'+id).innerHTML = 'verbergen';
          }
        }
      </script>";


$output  = html_header($title);
$output .= '<div class="syb">';
$output .= "<h2>$title</h2>";
$output .= '<div class="no_print">
              <p>Hinweis: die reinen Statistikdaten sind in einer Tabelle, d.h. ggf. auch bei einem Systemwechsel recht einfach mitzunehmen, sofern erforderlich. Papierausdrucke oder Kopien sind jedenfalls nicht notwendig... :)</p>
              <h3>Schnellübersicht
                <a href="javascript:toggle_visibility(\'visibility_links\')" id="toggle_visibility_links" class="toggle">anzeigen</a>
              </h3>
              <div id="visibility_links">
                <p>Reports wie sie bisher von Crystal Reports (CR) oder als SQR-Ausgabe generiert werden</p>
                <ul><li>'.implode('<br/><br/></li><li>', $links).'</li></ul>
              </div>
              <h3>Eigene Abfrage via Formular
                <a href="javascript:toggle_visibility(\'visibility_form\')" id="toggle_visibility_form" class="toggle">anzeigen</a>
              </h3>
              <div id="visibility_form">';
$output .=      $form;
$output .=    '</div>';
$output .= '<hr /></div>';
$output .= "<h2>$query_heading</h2>";
$output .= "<p>Stand: $now</p>";
$output .= $div_result;
$output .= '</div>';
$output .= $js;
$output .= html_footer();

echo $output;

?>