<?php
/*
 * *****************************************************************************
 * OUS: Noch nicht umgesetzte Vormerkungen (Selbstverbucherrückgaben)
 * *****************************************************************************
 * - Übername Intranet: 02.03.2015 /TZ
 * 
 * @note: TUB-Version Wiki: http://intranet.b.tu-harburg.de/mediawiki/index.php/Ausleihe (+Unterseite)
 *
 * @todo: ...
 */
// Datenbankverbindung
require_once('../../inc/lbs-conf.php');


/*
 * Variables
 */
$now   = date("d.m.Y H:i");
$title = "OUS: Noch nicht umgesetzte Vormerkungen & Magazinbestellungen";

$js = "<script type=\"text/javascript\">
        (function countdown(remaining) {
            if(remaining === 0)
                location.reload(true);
            document.getElementById('countdown').innerHTML = remaining;
            setTimeout(function(){ countdown(remaining - 1); }, 1000);
        })(60);
      </script>";

/*
 * Processing
 */
// TZ: Felder erst mal wieder rausgenommen; ggf. interessant:
// a.year Jahr, v.free_text Bandbemerkung, convert(char(10),r.reservation_date_time,104) Reservierung, borrower_bar Ausweis, Name=convert(varchar(50),(name+', '+ first_name_initials_prefix)),	b.free_text Notabene
$wrong_servertime_adjust = 0;
$query  = "SELECT
          	DATEADD(hour, $wrong_servertime_adjust, v.date_of_availability) 'Rückgabezeit',
            c.signature Signatur, v.volume_bar Barcode, c.author Autor, substring(c.shorttitle,1,70) 'Titel'
          FROM
          	reservation r,
          	borrower b,
          	volume v,
          	ous_copy_cache c,
          	acq_copy_cache a
          WHERE
          	r.iln = $iln
          	AND a.iln = $iln
          	AND b.iln = $iln
          	AND c.iln = $iln
          	AND v.iln = $iln
          	AND r.address_id_nr = b.address_id_nr
          	AND r.volume_number = v.volume_number
          	AND v.epn*=c.epn
          	AND v.epn*=a.epn
          	AND r.ppn=0
          	AND r.volume_number NOT IN (SELECT volume_number FROM loans_requests WHERE iln = $iln)
          ORDER BY
          	v.date_of_availability,
          	r.volume_number,
          	r.reservation_date_time
          ";
$result = sybase_query("$query", $conn) or die ("# ERROR: Query in Sybase failed $now \n"); // todo mail an admin

if (sybase_num_rows($result) > 0) {
  $table  = "<table>\n<tr><th>Rückgabezeit</th><th>Signatur</th><th>Barcode</th><th>Autor</th><th>Titel</th>\n</tr>\n";
  while ($row = sybase_fetch_array($result)) {
    $time = date('d.m.Y \u\m H:i', strtotime($row[0]));
    $table .= utf8_encode("<tr><td>$time</td><td class=\"left\">$row[1]</td><td>$row[2]</td><td class=\"left\">$row[3]</td><td class=\"left\">$row[4]</td></tr>\n");
  }
  $table .= '</table>';
} else {
  $table = 'Keine Vormerkungen auf dem Regal.<br />';
}

//Query 2 - Magazinbestellungen
$query  = "SELECT  lq.edit_date 'Datum', oc.signature 'Signatur',
          		(SELECT description FROM lbs_code_desc WHERE code_id = 1 AND convert(int, code_value) = lq.borrower_type and iln=$iln AND language_code = 'DE') 'Nutzertyp',
          		coalesce(substring(b.name, 1, patindex('% %', b.name)), b.name) 'Name',
          		(SELECT description FROM lbs_code_desc WHERE code_id = 10 AND convert(int, code_value) = lq.type_of_loan and iln=$iln AND language_code = 'DE') 'Ausleihart',
          		v.volume_bar 'Barcode',
          		substring(oc.shorttitle, 1, 40) 'Titel'
          FROM volume v
          	INNER JOIN ous_copy_cache oc ON v.epn = oc.epn
          	INNER JOIN loans_requests lq ON v.volume_number = lq.volume_number
          	INNER JOIN borrower b ON lq.address_id_nr = b.address_id_nr
          WHERE
          	v.iln = $iln
          	AND v.loan_status = 1 --bestellt
          	AND oc.signature not like 'FL:%'
          ORDER BY lq.edit_date desc
          ";
$result = sybase_query("$query", $conn) or die ("# ERROR: Query in Sybase failed $now \n"); // todo mail an admin

$table_mag  = "<table>\n<tr><th>Bestelldatum</th><th>Signatur</th><th>Nutzertyp</th><th>Für</th><th>Ausleihart</th><th>Barcode</th><th>Titel</th>\n</tr>\n";
while ($row = sybase_fetch_array($result)) {
  $time = date('d.m.Y \u\m H:i', strtotime($row[0]));
  $age_css = (strtotime('-30 minutes', time()) < strtotime($row[0])) ? 'style="color: red"' : '';
  $table_mag .= utf8_encode("<tr><td $age_css>$time</td><td class=\"left\">$row[1]</td><td>$row[2]</td><td class=\"left\">$row[3]</td><td class=\"left\">$row[4]</td><td class=\"left\">$row[5]</td><td class=\"left\">$row[6]</td></tr>\n");
}
$table_mag .= '</table>';

$output  = html_header($title);
$output .= '<div class="syb">';
$output .= "<h2>$title</h2>";
$output .= "<p>Stand: $now. - <a href=\"javascript:history.go(0)\">Jetzt aktualisieren</a> (<span id=\"countdown\"></span>) - <a href=\"http://intranet.b.tu-harburg.de/lbs/bib-tub/ous-public/ous_vormerkungen_sv.php\" target=\"Vormerkdruck\">Druckansicht</a></p>";
$output .= '<h3>Vormerkungen</h3>';
$output .= $table;
$output .= '<h3>Magazinbestellungen</h3>';
$output .= $table_mag;
$output .= '</div>';
$output .= $js;
$output .= html_footer();

echo $output;
?>
